<template>
    <div class="">
            <b-modal @hidden="reset"  size="lg" ref="chgdGdModal" id="my-modal-assurance" :title="ModalTitle"  :hide-footer="true">
                <form class="" method="POST"  @submit.prevent="update()" @reset.prevent="reset()" @keydown="form.errors.clear($event.target.name)"
                      @change="form.errors.clear($event.target.name)">
                                    <div class="form-row">
                                                    <div class="form-group col-md-4">
                                                        <label class="">Nom de code</label>
                                                        <input  class="form-control form-control-md form-custom-input-sm" name="libelle" v-model="form.libelle" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('libelle')" v-text="form.errors.get('libelle')"></span>
                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label for="inputState2">Prix de la location quotidienne</label>
                                                        <input id="inputState2" class="form-control form-control-md form-custom-input-sm" name="tarif" v-model="form.tarif" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('tarif')" v-text="form.errors.get('tarif')"></span>

                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label >Date  de mise en circulation</label>
                                                        <vc-date-picker :is-expanded="true"   @input="datepickerEvent" :masks="mask" mode="single" v-model="date_pmc" class="ml-1"></vc-date-picker>

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_mise_en_circulation')" v-text="form.errors.get('date_mise_en_circulation')"></span>

                                                    </div>
                                            </div>
                                            <div class="form-row">
                                                    <div class="form-group col-md-4">
                                                        <label class="">Marque</label>
                                                        <!-- <select id="inputState"  class="form-control form-control-md form-custom-input-sm" name="marque_id" v-model="form.marque_id" type="text">
                                                            <option value="">Choisissez svp</option>
                                                            <option>...</option>
                                                        </select> -->

                                                        <multi-select @input="trackMarque" name="marque_id"
                                                        v-model="marque" :show-labels="false"
                                                        open-direction="bottom" :close-on-select="true" placeholder="Choisissez la marque"
                                                        :options="opt.marques"   label="libelle" track-by="id">

                                                                <!-- <template><span slot="noOptions">Aucune route disponible</span></template> -->

                                                        </multi-select>

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('marque_id')" v-text="form.errors.get('marque_id')"></span>
                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label class="">Modèle</label>
                                                        <multi-select @input="trackModele" :disabled="!Modeles.length>0"
                                                        v-model="modele" :show-labels="false"
                                                        open-direction="bottom" :close-on-select="true" placeholder="Choisissez le modele"
                                                        :options="Modeles"   label="libelle" track-by="id">


                                                        </multi-select>

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('modele_id')" v-text="form.errors.get('modele_id')"></span>
                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label for="inputState4">Type de la voiture <small>(Forme)</small></label>
                                                        <multi-select
                                                                no-ptions="Aucun type de véhicule disponible" open-direction="bottom" name="type_vehicule_id"
                                                                v-model="tvehicule"  :options="opt.tvehicules"
                                                                @input="tvehicules => tvehicule!=null  ? form.type_vehicule_id = tvehicule.id : form.type_vehicule_id = ''"
                                                            :show-labels="false" :searchable="true" :clear-on-select="false"
                                                            :close-on-select="true"  placeholder="Le type de voiture" label="libelle" track-by="id" >
                                                        </multi-select>
                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('type_vehicule_id')" v-text="form.errors.get('type_vehicule_id')"></span>

                                                    </div>
                                            </div>
                                            <div class="form-row">


                                            </div>
                                            <div class="form-row">
                                                            <div class="form-group col-md-4">
                                                                <label class="">Type de motorisation</label>

                                                                <multi-select
                                                                    no-ptions="Aucun revendeur disponible" open-direction="bottom"
                                                                    v-model="motorisation"  :options="opt.motorisations"
                                                                    @input="motorisations => motorisation!=null  ? form.type_motorisation_id = motorisation.id : form.type_motorisation_id = null"
                                                                    :show-labels="false" :searchable="true" :clear-on-select="false"
                                                                    :close-on-select="true"  placeholder="Type de motorisation" label="libelle" track-by="id">
                                                                </multi-select>
                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('type_vehicule_id')" v-text="form.errors.get('type_vehicule_id')"></span>
                                                            </div>
                                                            <div class="form-group col-md-4">
                                                                <label for="inputState">Boite de vitesse <small>(Forme)</small></label>
                                                                <multi-select
                                                                    no-ptions="Aucun revendeur disponible" open-direction="bottom" name="boite_vitesse"
                                                                    v-model="form.boite_vitesse"  :options="['Automatique','Manuelle']"
                                                                    :show-labels="false" :searchable="true" :clear-on-select="false"
                                                                    :close-on-select="true"  placeholder="Boite de vitesse" >
                                                                </multi-select>
                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('boite_vitesse')" v-text="form.errors.get('boite_vitesse')"></span>

                                                            </div>
                                                            <div class="form-group col-md-4">
                                                                <label class="">Consommation au 100 km</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="consommation_au_100_km" v-model="form.consommation_au_100_km" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('consommation_au_100_km')" v-text="form.errors.get('consommation_au_100_km')"></span>
                                                            </div>
                                            </div>
                                            <div class="form-row">
                                                    <div class="form-group col-md-4">
                                                        <label class="">Etat du kilométrage</label>
                                                        <input id="inputState6" class="form-control form-control-md form-custom-input-sm" name="kilometrage" v-model="form.kilometrage" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('kilometrage')" v-text="form.errors.get('kilometrage')"></span>
                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label for="inputState7">Plaque d'immatriculation</label>
                                                        <input id="inputState7" class="form-control form-control-md form-custom-input-sm" name="plaque_immatriculation" v-model="form.plaque_immatriculation" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('plaque_immatriculation')" v-text="form.errors.get('plaque_immatriculation')"></span>

                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label class="">N° de chassis</label>
                                                        <input  class="form-control form-control-md form-custom-input-sm" name="nr_chassis" v-model="form.nr_chassis" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('nr_chassis')" v-text="form.errors.get('nr_chassis')"></span>
                                                    </div>

                                            </div>
                                            <div class="form-row">
                                                    <div class="form-group col-md-4">
                                                        <label class="">Nombre de porte</label>
                                                        <input  class="form-control form-control-md form-custom-input-sm" name="nbr_porte" v-model="form.nbr_porte" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('nbr_porte')" v-text="form.errors.get('nbr_porte')"></span>
                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label for="inputState1">Nombre de place</label>
                                                        <input id="inputState1" class="form-control form-control-md form-custom-input-sm" name="nbr_place" v-model="form.nbr_place" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('nbr_place')" v-text="form.errors.get('nbr_place')"></span>

                                                    </div>

                                                    <div class="form-group col-md-4">
                                                        <label class="">Couleur</label>
                                                        <input  class="form-control form-control-md form-custom-input-sm" name="couleur" v-model="form.couleur" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('couleur')" v-text="form.errors.get('couleur')"></span>
                                                    </div>
                                            </div>
                    <div class="m-form__actions m-form__actions--solid mt-3" style="    display: flex;align-items: center;justify-content: flex-end;">
                        <button type="submit" :class="['btn btn-success btn-small ',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="form.errors.any() || isLoading">{{ isLoading ? "Processus en cours..." : ModalAction }}</button>
                    </div>
                </form>
            </b-modal>
            <!-- Modal fin -->
        </div>
</template>

<script>

    import Form from "./../../classes/Form"


    export default {
        props:[],
        data(){
            return{
                //VC-calendar
                mask:{

                    input: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                    data: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                },
                date_pmc:"",

                //multi-select
                marque:"",
                modele:"",
                motorisation:"",
                permis:"",
                tvehicule:"",

                //Options selectionnées
                plaisirs : [],
                conforts : [],
                securites : [],

                modeles : [],
                opt:{
                    marques:[],
                    motorisations:[],
                    tvehicules:[],
                    optConfort:[],
                    optPlaisir:[],
                    optSecurite:[],
                    tpermis:[],
                },
                form : new Form(
                    {
                        image_mise_en_avant:"",
                        images:[],
                        marque_id:"",
                        modele_id:"",
                        libelle:"",
                        type_vehicule_id: "",
                        type_permis_id: "",
                        step:0,

                        options:[],

                        nbr_place: "",
                        nbr_porte: "",
                        couleur: "",

                        //tarifs
                        tarif: "",
                        kilometrage: "",

                        //unicités
                        plaque_immatriculation: "",
                        nr_chassis: "",

                        date_mise_en_circulation: "",
                        annee_mise_en_circulation: "",
                        consommation_au_100_km: "",

                        //moteurs
                        type_motorisation_id: "",
                        boite_vitesse: "",

                        //mesures physiques
                        volume_coffre: "",
                        volume_reservoir: "",
                        largeur: "",
                        longueur: "",
                        poids: "",
                        hauteur: ""
                  }),
                isLoading:false,
            }
        },
        created()
        {
               this.modeEdit = false
               axios.get("/api/dispatcher/options/vehicules").then((response) =>
                {
                      this.opt.marques = response.data.marques.filter( e => {

                       return  e.modeles.length>0
                      })
                      this.opt.motorisations = response.data.motorisations
                      this.opt.tpermis = response.data.tpermis
                      this.opt.tvehicules = response.data.tvehicules


                      //envoie un event pour signifier le chargement des options
                },
                (error) =>
                {
                  this.isLoading = false
                });
             
          
        },
        mounted() {

              window.event.$on('change-general-data-event',(vehicule) =>
             {
                 this.entity = vehicule
                 this.showModal()
             })
        },
        computed:
            {
                ModalTitle ()
                {
                    return "Modification : Données Générales"
                },
                ModalAction ()
                {
                    return  " Valider"
                },
                Modeles()
                {
                if(this.marque==null || this.marque=="" || this.marque==undefined)
                return  []
                else
                return this.marque.modeles
                },
            },
        methods:
            {

                //Event sur le date picker
                datepickerEvent(event,name)
                {
                    if(name=="date_dbt")
                    {
                        this.form.date_dbt = moment(event).format('YYYY-MM-DD')
                        this.form.checkError(name)

                    }
                    if(name=="date_fin")
                    {
                    this.form.date_fin = moment(event).format('YYYY-MM-DD')
                    this.form.checkError(name)
                    }
                },
                //Actualise les données générales
                update()
                {
                    this.isLoading = true ;
                    //Requête ajax
                    this.form.patch("/api/vehicules/"+this.entity.id+"/base").then((response) =>
                        {
                            if(response.success)
                            {
                             flash("<span>Enregistré <strong>avec succès</strong></span>")
                              window.event.$emit('updated-general-data-event',response.entity)
                            }
                            else
                            {
                             flash("<span>Ajout<strong> impossible</strong></span>","error")
                            }
                           this.reset()
                           this.isLoading = false ;

                        },
                        (error) =>
                        {
                            this.isLoading = false
                        });
                },
                //On affiche le modal 
                showModal()
                {

                    this.modeEdit = false
                    this.init()
                    this.$refs['chgdGdModal'].show()

                },

                //Initialisation du formulaire
                reset()
                {
                    this.init();
                    this.$refs['chgdGdModal'].hide()
                    this.modeEdit = false
                    this.isLoading = false
                },
                init()
                {
                    this.form.marque_id=this.entity.marque_id,
                    this.form.modele_id=this.entity.modele_id,
                    this.form.libelle=this.entity.libelle,
                    this.form.type_vehicule_id= this.entity.type_vehicule_id,
                    this.form.type_permis_id= this.entity.type_permis_id,
                    this.form.type_motorisation_id= this.entity.type_motorisation_id,

                    this.form.nbr_place= this.entity.nbr_place,
                   this.form. nbr_porte= this.entity.nbr_porte,
                   this.form.couleur= this.entity.couleur,

                    //tarifs
                    this.form.tarif= this.entity.tarif,
                    this.form.kilometrage= this.entity.kilometrage,

                    //unicités
                    this.form.plaque_immatriculation= this.entity.plaque_immatriculation,
                    this.form.nr_chassis= this.entity.nr_chassis,

                    this.form.date_mise_en_circulation= this.entity.date_mise_en_circulation,
                    this.date_pmc = moment(this.form.date_mise_en_circulation).toDate()

                    this.form.annee_mise_en_circulation= moment(this.form.date_mise_en_circulation).year(),
                    this.form.consommation_au_100_km= this.entity.consommation_au_100_km,

                    //moteurs

                    this.form.boite_vitesse= this.entity.boite_vitesse,

                    //mesures physiques
                    this.form.volume_coffre= this.entity.volume_coffre,
                    this.form.volume_reservoir= this.entity.volume_reservoir,
                    this.form.largeur= this.entity.largeur,
                    this.form.longueur= this.entity.longueur,
                    this.form.poids= this.entity.poids,
                    this.form.hauteur= this.entity.hauteur,

                    this.marque = this.opt.marques.find(e =>  e.id == this.form.marque_id)
                    this.modele = this.marque.modeles.find(e =>  e.id == this.form.modele_id)
                    this.motorisation = this.opt.motorisations.find(e => e.id == this.form.type_motorisation_id )
                    this.tvehicule = this.opt.tvehicules.find(e =>  e.id == this.form.type_vehicule_id)

            },
             // Events
             trackMarque(e)
             {
                 if(e!=null)
                 {
                   this.form.marque_id = e.id
                   this.modeles = e.modeles
                   this.modele=""
                   this.form.modele_id = ""
                 }
                 else
                 {
                   this.modele =""
                   this.form.modele_id = ""
                 }


             },
              trackModele(e)
             {
                 if(e!=null)
                 {
                   this.form.modele_id = e.id
                 }
                 else
                 {
                   this.form.modele_id =""
                 }
             },
            trackTM(e)
             {
                 if(e!=null)
                 {
                   this.form.modele_id = e.id
                 }
                 else
                 {
                   this.form.modele_id =""
                 }
             }
            },
        components:
            {

            }
    }
</script>
